#include <mathlink.h>
#include <stdio.h>
#include "gmp.h"
#include <conio.h>
#include <stdlib.h>
#include <windows.h>
#include <math.h>
#include <process.h>
#include <string.h>
#define RELEASE//
#define _CRT_SECURE_NO_WARNINGS 1
char* szResultFile;
//struktura pouit pi pedvn parametr novmu vlknu
struct Suma2StructType
	{
	unsigned int Max;
	unsigned int n;
	};

//Maximln d je 23 - vce nehomu najednou v 32-bitovem prosted naadresovat
#define MAX 23
//Protoe pro indexaci koeficient je teba 2^(23+1)=16M index
#define MAXLBITINDEX 17000000
//A pomocn pole jsou 3, o velikostech MAXLBITINDEX x (1. int(4byty) + 2. LONG(4byty) + 3. mpq_t(24byt))
//tj. celkem 16M*(32byt) = 568 MB virtualn pamti pro uchovn informac o koeficientech (nejlpe v RAM)
mpq_t koef[MAXLBITINDEX];
//mpq_t koef[2];
//zmek koeficient - aby se stejnm koeficientem nepotalo vce clken najednou
LONG  g_fPoleKoefLock[MAXLBITINDEX];
int iPoleDelekVyrazuUKoef[MAXLBITINDEX];
//men asu - sem se ulo poten as
DWORD g_dwStart;
// zmky promnnch
LONG g_fStdOutLock; // zmek standartnho vstupu
LONG g_fPoleDelekIndexuLock;// zmek pole dlek pro 
//LONG g_fPoleKoefInUse;
extern char * Formule(int Max,char* szFileName);

mpz_t factorial[MAX][MAX];
//******InicializujPoleFaktorialu*****//
//- napot faktorily danho du a to pro pouit pro kad vlkno zvl᚝
void InicializujPoleFaktorialu(unsigned int Max)
	{
	unsigned int n,i;
	for(n=1;n<=Max;n++)
		{
		for(i=1;i<=Max;i++)
			{
			mpz_init(factorial[n][i]);
			mpz_fac_ui(factorial[n][i],i); //faktoril knihovny gmp
			}
		}
	};
//******DeinicializujPoleFaktorialu*****//
//- vyist pam po faktorilech
void DeinicializujPoleFaktorialu(unsigned int Max)
	{
	unsigned int n,i;
	for(n=1;n<=Max;n++)
		{
		for(i=1;i<=Max;i++)
			{
			mpz_clear(factorial[n][i]);
			}
		}
	};

//******WriteInfo*****//
//- Spout se na konci jednotlivch vlknech a zobrazuje informace o dob trvn danho vlkna
void WriteInfo(unsigned int n)
	{
	//Pokat v ppad zamenho zdroje
	while (InterlockedExchange (&g_fStdOutLock, 1) == 1)
		Sleep(0);
	
	printf("BCH term of %dth order finished in ",n);
	printf("%d ms\n",GetTickCount()-g_dwStart);
	//Odemknout zdroj
	InterlockedExchange(&g_fStdOutLock, 0);
	}

//******Suma2*****//
//Tato funkce pot vnitn dvojnou sumu ve vzorci pro BCH formuli
//Max-maximln poadovan stupe pesnosti
//n- n-tkrok vnj sumy. Uruje kolik je index si a ri

int Suma2(int Max, int n)
	{
	//********************
	//Deklarace promnnch
	mpq_t rPartKoef;
	int iBitIndex;//pro index psluejc uritmu slovu
	//pro urychlen algoritmu, peskoeni zbytench sloupc
	int iMinj, bPouzitMinj, iPocetNenulSloupcu,iPoslNenulSloupec;
	int nenulSloupce[MAX * 2 + 1];
	int poleJeVNenulSloupci[MAX * 2 + 1];
	//pole indexu s a r pro sumu
	int sr[MAX * 2 + 1]; //posledni plus jedna je kvuli tomu ze prvni index je jinak nula
	//potadla do cykl
	int i, j,iPomPoc;
	int iSum;	//zde je celkov souet index s a r, tedy poet psmen slova typu (xyxy...)
	//********************	
	//Inicializace promnnch
	mpq_init(rPartKoef);
	//poten nastaven index s a r
	iSum=0;
	sr[2*n] = 0;
	for (i = (2 * n-1 ); i >= n+1; i--)	{sr[i] = 1;iSum++;} //alespo polovina index mus bt nenulov
	for (i = n; i >= 0; i--)	{sr[i] = 0;}
	//nasteven pomocnch promnnch
	bPouzitMinj=0;
	iMinj=1;
	iPocetNenulSloupcu=0;
	iPoslNenulSloupec=2*n-1;
	for (i = 0; i <= 2*n; i++)	{
		nenulSloupce[i] = 0;
		poleJeVNenulSloupci[i]=0;
		if(sr[i]!=0)
			{
			nenulSloupce[++iPocetNenulSloupcu] = i;
			poleJeVNenulSloupci[i]=1;
			}
		}
	//********************	
	//Algoritmus - vnitn suma vzorce
	//generovn vech monch kombinac index si a ri kon
	//dje se postupnm zvtovnm index smrem odzadu
	//cel proces kon zvenm nulovho indexu, kter je pouze pomocn
	//Reln indexy jsou sr[1] a sr[2n]
	while (sr[0] == 0)
		{
		if (iSum>=(Max))//souet nesm bt vt ne poadovan d pesnosti
			goto Nuluj;
		for (i = (2 * n ); i >= 0; i--)//zvyovn index od poslednho
			{
			
			if ((sr[i]+1) <= (Max-n)+1)//zda jet nco zbv pro dan index (po rozdlen alespo po jednom do vech index)
				{
				sr[i]++;	//podmnky splnny, index lze zvtit
				iSum++;
				//uspsoben informac o nulovch sloupcch
				if(poleJeVNenulSloupci[i]==0)
					{iPomPoc=iPocetNenulSloupcu;
					while(nenulSloupce[iPomPoc]>i)
						{nenulSloupce[iPomPoc+1]=nenulSloupce[iPomPoc];
						iPomPoc--;}
					nenulSloupce[iPomPoc+1]=i;
					poleJeVNenulSloupci[i]=1;
					iPocetNenulSloupcu++;
					if(i>iPoslNenulSloupec)iPoslNenulSloupec=i;
					}
				//kontrola vlastnost index
				for (j = iMinj; j <= n; j++)
					{
					//St se pes vechny i kdy si+ri>0
					if (sr[n + j ] + sr[j ] == 0)
						{//oznaen problmovho indexu pro nslednou optimalizaci
						if(j<n)
							{
							iPomPoc=iPoslNenulSloupec;
							while(iPomPoc>(n+j))
								{
								iSum-=sr[iPomPoc];
								sr[iPomPoc]=0;
								nenulSloupce[iPocetNenulSloupcu]=0;
								iPocetNenulSloupcu--;
								poleJeVNenulSloupci[iPomPoc]=0;				
								iPoslNenulSloupec=nenulSloupce[iPocetNenulSloupcu];
								iPomPoc=iPoslNenulSloupec;
								}
							iMinj=j;
							if(iSum>=Max)
								goto Nuluj;
							i=n+j+1;
							goto ZaNuluj; 
							}//if(j<n)
						else //j je n
							goto ZaFor;
						}//if (sr[n + j ] + sr[j ] == 0)
					}
				//Jet kontrola abychom nezapisovali slova konc na mocninu yy
			/*	if(n>1 && sr[n]==0 && sr[n-1]==0) //yy
					goto ZaFor;
				if(n>1 && sr[n]==1 && sr[2*n]==0 && sr[n-1]!=0)
					goto ZaFor;
				*/	
				//nyn se spot koeficient u slova odpovdajcho indexm si a ri a tak pomocn index
				mpq_set_ui(rPartKoef,1,1);
				iBitIndex=1;
				for (j = 1; j <= n; j++)
					{
					//pomocn index - zana 1 a pak 0 za x a 1 za y
					iBitIndex<<=sr[n+j];
					for(iPomPoc=0;iPomPoc<sr[j];iPomPoc++)
						{iBitIndex<<=1;	iBitIndex++;}//za kad y 1
					//zatek prav etzce	
					if(sr[n+j]>1)//faktorilem 1 nem cenu nsobit
						mpz_mul(&rPartKoef->_mp_den,&rPartKoef->_mp_den,factorial[n][sr[n+j]]);
					if(sr[j]>1)//faktorilem 1 nem cenu nsobit
						mpz_mul(&rPartKoef->_mp_den,&rPartKoef->_mp_den,factorial[n][sr[j]]);
					}//	for (j = 1; j <= n; j++)
				mpz_mul_si(&rPartKoef->_mp_den,&rPartKoef->_mp_den,n);	//*1/n
				while (InterlockedExchange (&g_fPoleDelekIndexuLock, 1) == 1)Sleep(0);//Pokat v ppad zamenho zdroje
				iPoleDelekVyrazuUKoef[iBitIndex]=iSum;//zape jak dlouh je slovo psluejc indexu	
				InterlockedExchange(&g_fPoleDelekIndexuLock, 0);//Odemknout zdroj
				//podle toho zda n je sud se k sum pit nebo odt
				if(n%2==0)
					{while (InterlockedExchange (&g_fPoleKoefLock[iBitIndex], 1) == 1)Sleep(0);//Pokat v ppad zamenho zdroje
					mpq_sub(koef[iBitIndex],koef[iBitIndex],rPartKoef);
					InterlockedExchange(&g_fPoleKoefLock[iBitIndex], 0);//Odemknout zdroj
					}
				else
					{while (InterlockedExchange (&g_fPoleKoefLock[iBitIndex], 1) == 1)Sleep(0);//Pokat v ppad zamenho zdroje
					mpq_add(koef[iBitIndex],koef[iBitIndex],rPartKoef);
					InterlockedExchange(&g_fPoleKoefLock[iBitIndex], 0);//Odemknout zdroj
					}
				goto ZaFor;//slovo zapsno, pejt k tvorb dalho
				}//if((sr[i]+1) <= (Max-n)+1)
			else //((sr[i]+1) > (Max-n)+1)
				{//dojde k nulovn poslednho nenulovho indexu			
Nuluj:;//nvst
		  {		//nastaven pomocnho indexu iMinj
				if(iPoslNenulSloupec<=n)
					{
					if(iMinj>iPoslNenulSloupec)
						{
						iMinj=iPoslNenulSloupec;
						if(iMinj<=0)
							iMinj=1;
						}

					}		
				else if(iMinj>(iPoslNenulSloupec-n) && poleJeVNenulSloupci[iPoslNenulSloupec-n]==0)
					{
					iMinj=iPoslNenulSloupec-n;
					if(iMinj<=0)
						iMinj=1;
					}
				//samotn nulovn
				iSum-=sr[iPoslNenulSloupec];//zmenen soutu index o nulovan index
				sr[iPoslNenulSloupec]=0;
				poleJeVNenulSloupci[iPoslNenulSloupec]=0;
				iPocetNenulSloupcu--;
				iPomPoc=iPocetNenulSloupcu;
				while(nenulSloupce[iPomPoc]>(iPoslNenulSloupec))
					{nenulSloupce[iPomPoc]=nenulSloupce[iPomPoc+1];
					iPomPoc--;
					}
				nenulSloupce[iPocetNenulSloupcu+1]=0;	
				poleJeVNenulSloupci[nenulSloupce[iPocetNenulSloupcu+1]]=0;
				iPoslNenulSloupec=nenulSloupce[iPocetNenulSloupcu];
		  }
ZaNuluj:;
				}//else((sr[i]+1) > (Max-n)+1)
			}//for (i = (2 * n ); i >= 0; i--)
ZaFor:;//oznaen bloku
		}//while (sr[0] == 0)
	//konec cyklu, suma je hotova
	//Deinicializace
	mpq_clear(rPartKoef);
	//Zobrazen informac o danm kroku
	WriteInfo(n);
	return 0;
	}

//******Suma2ThreadMain*****//
//Hlavn funkce novho vlkna, m za kol spustit funkci Suma2 se zadanmi parametry
unsigned __stdcall Suma2ThreadMain(void* pArgs)
	{
	//Deklarace
	struct Suma2StructType *structSuma2;
	int Max, n;
	//petypovn argumentu a vyzvednut informac z nj
	structSuma2=(struct Suma2StructType*) pArgs;
	Max=structSuma2->Max;
	n=structSuma2->n;
	//sputn funkce Suma2
	Suma2(Max,n);
	//Deinicializace
	if(structSuma2)
		free(structSuma2);	
	//ukonen vlkna
	_endthreadex( 0 );
	return 0;

	}

//******InicializujKoef*****//
//Funkce inicializuje pole promnnch typu mpq_t
//vrac maximln index slov, tedy velikost pole koeficient = 2^(Max+1)
_inline int InicializujKoef(int Max)
	{
	//Deklarace promnnch
	int j,iMaxBitIndex;
	int iFreeVM1,iUsedVMByMpq;//virtual memory
	MEMORYSTATUS stat;
	//spoten 2^(Max+1)
	iMaxBitIndex=2;
	iMaxBitIndex<<=Max;
	//Zskn informac o voln virtuln pamti
	GlobalMemoryStatus (&stat);
	iFreeVM1=(unsigned int)stat.dwAvailVirtual;
	iUsedVMByMpq=128;//poet byt potebnch pro inicializaci promnn typu mpq_t
	//rezerva 10MB ve virtuln pamti
	if ((((iFreeVM1-(10*1024*1024))/(iUsedVMByMpq/2))<iMaxBitIndex))
		return 0;//nen dostatek virtuln pamti
	//pamti je dostatek (alespo pro nsledujc inicializace
	
	for (j=1;j<iMaxBitIndex+1;j++)
		{
		mpq_init(koef[j]);
			
		iPoleDelekVyrazuUKoef[j]=0;
		g_fPoleKoefLock[j]=0;
		}
	
	return iMaxBitIndex;
	}

//******RunThreads*****//
//spust Max vlken, kter zajst spotn Max vnitrnch sum BCH-formule
void RunThreads(int Max)
	{
	//Deklarace promnnch
	unsigned threadID;
	int iPoc;
	void **lpHandles;
	struct Suma2StructType *structSuma2;
	//Inicializace
	lpHandles=(void**)malloc(Max*sizeof(void*));//ukazatele na budouc vlkna
	//cyklus spoutjc Max vlken
	for (iPoc = Max; iPoc >= 1; iPoc--)
		{
		//pro kad vlkno je teba jinch paramatr
		structSuma2=malloc(sizeof(struct Suma2StructType));
		structSuma2->Max=Max;
		structSuma2->n=iPoc;
		lpHandles[iPoc-1] = ((void*)_beginthreadex( NULL, 0, &Suma2ThreadMain, (void *) (structSuma2), 0,  &threadID));
		//nastaven prioriot pro vlkna - odpozorovan z du 14
		if((iPoc<=(Max*4/14)) | (iPoc==Max))
			SetThreadPriority(lpHandles[iPoc-1],-15);//idle
		else if(iPoc>=(Max*7/14) && iPoc<=(Max*11/14))
			SetThreadPriority(lpHandles[iPoc-1],0);//normal
		else if((iPoc<=(Max*7/14)) && (iPoc>=(Max*5/13)) || (iPoc<=(Max*13/14)) && (iPoc>=(Max*11/13)))
			SetThreadPriority(lpHandles[iPoc-1],-2);//lowest
	
		}
	//pok na dokonen vech vlken
	WaitForMultipleObjects(Max,lpHandles,TRUE,INFINITE);
	}

//******ReturnPointerToResult*****//
//Opens the file containing the result and returns the pointer to the characters in that file
//It does not close the mapping to the file and even not the file itself
char *ReturnPointerToResult()
	{
	//Deklarace promnnch
	char *pZacatekSouboru;
	HANDLE hfilemap,hFile;
	//Oteven souboru
	hFile = CreateFileA(szResultFile,GENERIC_READ ,FILE_SHARE_READ ,NULL, OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE) return "Error opening file with result";
	//Namapovn souboru
	hfilemap = CreateFileMapping(hFile, NULL, PAGE_READONLY, 0, 0, NULL);
	if(NULL==hfilemap) {CloseHandle(hFile);return "Error while mapping the resulting file";}
	//Nastaven ukazatele na potek mapovan (tedy na zatek souboru)
	pZacatekSouboru = (PCHAR) MapViewOfFile(hfilemap, FILE_MAP_READ, 0, 0, 0); //map the entire file
	if(pZacatekSouboru==0) {return "Error assigning the pointer to the mapping" ;}
	//return the pointer to the begining of the mapped file
	return pZacatekSouboru;
	/*	UnmapViewOfFile(pZacatekSouboru);
	CloseHandle(hfilemap);
	CloseHandle(hFile);
	*/
	}

//******WriteResult*****//
//Write the coefficients from array to the resulting file
int WriteResult(int iMaxBitIndex, int Max)
	{
	//Deklarace promnnch
	char *pZacatekSouboru, *pDoSouboru, *pDoSlova,*szSlovo,*szKoef;
	HANDLE hfilemap, hFile;
	//booleans
	int bDekodovaneJ, bEnd;
	//auxiliary variables
	int iMod, iPoc,j,jPom;
	int iOdhadDelkyKoef, iOdhadDelkySlova, iOdhadDelkySouboru;
	//Inicializace
	iOdhadDelkyKoef=(int)(Max*1.5); //odpozorovno 13,14,15,16-d-18 pozic, 17-d-23 pozic
	szKoef=(char*)malloc(sizeof(char)*iOdhadDelkyKoef+128);//buffer pro uloen selnho koeficientu uritho slova (xyx...)
	//5 pro interpunkci + 2xMax pro slovo s tekama (x.y....) + iOdhadDelkyKoef
	iOdhadDelkySlova=5+2*Max+iOdhadDelkyKoef;
	szSlovo=(char*)malloc(sizeof(char)*iOdhadDelkySlova+512);//buffer pro uloen uritho slova (xyx...) splou s koeficientem - tedy slova danho du
	//poet 
	iOdhadDelkySouboru=(iMaxBitIndex*iOdhadDelkySlova)/2;
		printf("\nOdhad delky souboru:%d\n",iOdhadDelkySouboru);
	hFile = CreateFileA(szResultFile,GENERIC_READ | GENERIC_WRITE,FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE) return 1;
	
	//Pipraven souboru pro zpis
	hfilemap = CreateFileMapping(hFile, NULL, PAGE_READWRITE, 0, iOdhadDelkySouboru, NULL);
		if(NULL==hfilemap) {CloseHandle(hFile);return 1;}
	pZacatekSouboru = (PCHAR) MapViewOfFile(hfilemap, FILE_MAP_WRITE, 0, 0, 0); 
	if(pZacatekSouboru==0) 
		{CloseHandle(hFile);CloseHandle(hfilemap);return  1;}
	strcpy(pZacatekSouboru,"");//Vyitn souboru
	pDoSouboru=pZacatekSouboru;//vychoz nastaven pomocnho ukazatele
	//Samotn algoritmus prochzen koeficient a zapisovn spolen s pslunm slovem
	for (j=1;j<iMaxBitIndex;j++)
		{
		szSlovo[0]=0;pDoSlova=szSlovo;
		bDekodovaneJ=0;
		if(iPoleDelekVyrazuUKoef[j]!=0 && mpq_cmp_si(koef[j],0,1)!=0)
			{if(!bDekodovaneJ)
				{jPom=j;
				pDoSlova=szSlovo;
				pDoSlova[0]='+';
				pDoSlova++;
				for(iPoc=0;iPoc<iPoleDelekVyrazuUKoef[j];iPoc++)
					{iMod=jPom%2;
					jPom>>=1;
					pDoSlova[0]=(char)(120+iMod);pDoSlova++;//zape x i y
					//pDoSlova[0]='.';pDoSlova++;
					}
				//pDoSlova--;	
				pDoSlova[0]=0;
				szSlovo++;_strrev(szSlovo);szSlovo--;//obrcen slova
				strcpy(pDoSlova,"*(");pDoSlova+=2;
				bDekodovaneJ=1;
				}
			gmp_sprintf (szKoef,"%Qd", koef[j]);			
			strcpy(pDoSlova,szKoef);pDoSlova+=strlen(szKoef);
			mpq_clear(koef[j]);
			}
		if(szSlovo[0]!=0)
			{strcpy(pDoSlova,")");pDoSlova++;
			strcpy(pDoSouboru,szSlovo);
			pDoSouboru+=strlen(szSlovo);
			}
		}//for (j=1;j<iMaxBitIndex;j++)
	//Nastav konec souboru a ukon prci s nm
	SetFilePointer(hFile,(int)strlen(pZacatekSouboru),NULL,FILE_BEGIN);
	printf("Delka souboru:%d\n",(int)strlen(pZacatekSouboru));
	UnmapViewOfFile(pZacatekSouboru);
	CloseHandle(hfilemap);
	bEnd=SetEndOfFile(hFile);
	CloseHandle(hFile);
	//Deinicializace
	free(szSlovo);
	free(szKoef);
	return 0;
	}



//******Formule*****//
//Vrt etzec reprezentujc BCH formuli
char* Formule(int Max,char *szFileName)
	{
	//Deklarace promnnch
	MEMORYSTATUS stat;
	int iMaxBitIndex;
	double dPotrebnaPamet;
	unsigned iPotrebnaPamet,iFreeVM;
	if(Max<0)return "Error:Order can not be 0 or less";
	if(Max>23)return "Error:Maximum calculateable order is in this 32bit version limited to 23";
	//Inicializace
	szResultFile=szFileName;
	g_fStdOutLock=0;
	g_fPoleDelekIndexuLock=0;
	g_dwStart = GetTickCount();//Poten as pro zmen as jednotlivch vlken
	iMaxBitIndex=InicializujKoef(Max);//Inicializace koeficient
	if(iMaxBitIndex==0)//0 ukazuje na chybu pi alokaci pamti
		{
		GlobalMemoryStatus (&stat);iFreeVM=(int)(stat.dwAvailVirtual);//zjitn velikosti voln virtuln pamti
		//napotn potebn pamti pro alokaci
		iPotrebnaPamet=2;iPotrebnaPamet<<=Max;
		dPotrebnaPamet=(double)iPotrebnaPamet;dPotrebnaPamet*=64.;dPotrebnaPamet+=1024*1024;
		printf("k vypoctu radu %d je treba %f bytu virtualni pameti \n",Max,dPotrebnaPamet);
		printf("ale k dispozici jest pouze %u bytu",iFreeVM);
		return "Not enough virtual memory available, see console output for detailed info";
		}
	InicializujPoleFaktorialu(Max);
	//Main
	RunThreads(Max);
	//Write the result into the file
	WriteResult(iMaxBitIndex,Max);
	//Deinitializations
	DeinicializujPoleFaktorialu(Max);
	return ReturnPointerToResult();
	}
#ifndef RELEASE
int main(int argc, char *argv[]) 
	{//rychla - 11 rad 2,7 s
	int rad;
	//NASTEJNo
	rad=14;//,4s vs 5,6s 14-7.3s-6.8s,15-21s
	Formule(rad,"c:/BCHfle.txt");//JEN MINIMALNI ZPOZDENI//11-38000

	//printf(dwCelkem;
	_getch();
	return 1;
	//	return MLMain(argc, argv);

	}
#endif

#ifdef RELEASE
#if MACINTOSH_MATHLINK

int main( int argc, char* argv[])
	{
	// Due to a bug in some standard C libraries that have shipped with
	// MPW, zero is passed to MLMain below.  (If you build this program
	// as an MPW tool, you can change the zero to argc.)

	argc = argc; 
	return MLMain( 0, argv);
	}

#elif WINDOWS_MATHLINK

#if __BORLANDC__
#pragma argsused
#endif

int PASCAL WinMain( HINSTANCE hinstCurrent, HINSTANCE hinstPrevious, LPSTR lpszCmdLine, int nCmdShow)
	{
	char  buff[512];
	char FAR * buff_start = buff;
	char FAR * argv[32];
	char FAR * FAR * argv_end = argv + 32;

	hinstPrevious = hinstPrevious; 

	if( !MLInitializeIcon( hinstCurrent, nCmdShow)) return 1;
	MLScanString( argv, &argv_end, &lpszCmdLine, &buff_start);
	return MLMain( argv_end - argv, argv);
	}

#else

int main(int argc, char* argv[])
	{
	return MLMain(argc, argv);
	}

#endif
#endif
