(* ::Package:: *)

(*
	This packgage mediates an access to the external program Formule.exe, that \
is programmed in C and contains a function Formule [A,B,m]. It returns the \
Baker-Campbell-Hausdorff formula of elements A and B computed to the m-th \
order of precision.
*)
BeginPackage["Propagator`BCHfle`"]
BCHCfleForDynkinSubst::usage="BCHCfleForDynkinSubst[A_, B_,RAD_Integer] gives the expression of the Baker-Campbell-Hausdorff formula calculated to the RAD-th order."
BCHCfleForDynkinSubst[RADbchfleparama_Integer]:=Module[{fle,link},
link = Install["Propagator\\BCHfleD.exe"];
fle=ToExpression[Formule[RADbchfleparama,"C:/BCHfleD.txt"]]//Expand;
LinkClose[link];
fle]
BCHCfle::usage="BCHCflet[RAD_Integer] gives the expression of the Baker-Campbell-Hausdorff formula calculated to the RAD-th order."
BCHCfle[RADbchfleparama_Integer]:=Module[{fle,link},
link = Install["Propagator\\BCHfle.exe"];
fle=ToExpression[Formule[RADbchfleparama,"C:/BCHfle.txt"]]//Expand;
LinkClose[link];
fle]
EndPackage[]



